﻿;==========================================================================================================================
; Import a RecipeMuncher XML file
;==========================================================================================================================

Procedure ImportRecipeMuncherFile(ImportFileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected.i Result, XML
  
  Protected.q Size
  
  Protected *Buffer, *Node
  
  ;------------------------------------------------------------------------------------------------
  ; Count the old number of items in the display
  ;------------------------------------------------------------------------------------------------
  
  Program\RecipeCounter  = Val(CountRecords("SELECT COUNT(Record) AS totalrecs FROM recipes"))

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ImportFileHandle.i = ReadFile(#PB_Any, ImportFilename.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If ImportFileHandle.i
    
    ;----------------------------------------------------------------------------------------------
    ; Show the currently processed file on the import window title bar
    ;----------------------------------------------------------------------------------------------
    
    ShowImportFileNames(ImportFileName.s)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    Size = Lof(ImportFileHandle.i)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    *Buffer = AllocateMemory(Size)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    If *Buffer
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If ReadData(ImportFileHandle.i, *Buffer, Size) = Size
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        XML = CatchXML(#PB_Any, *Buffer, Size)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If XML
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          *Node = MainXMLNode(XML)
          
          If *Node
            
            ImportRecipeMuncherFile_XML(*Node, 0)
            
          EndIf
          
          FreeXML(XML)
          
          Recipe\Categories   = Trim(Recipe\Categories,  ",")
          
          Recipe\Ingredients  = Trim(Recipe\Ingredients, "|")
          
          Recipe\Instructions = Trim(Recipe\Instructions)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------

          ImportRecipeFileSave(#Program)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          ; Could not read the xml tree
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
          
      Else
        
        ; Could not read the data from the file
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      FreeMemory(*Buffer)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      ; Mo buffer was defined
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CloseFile(ImportFileHandle.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ; No file handle was found for the recipe file
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 34
; FirstLine = 1
; Folding = -
; EnableXP