﻿;==============================================================================================================================================================================
; Need a unicode aware version of the API directory creator
;==============================================================================================================================================================================

Import "shell32.lib"                                                                                ; 
  SHCreateDirectory(*hwnd, pszPath.p-unicode)                                                        ; 
EndImport                                                                                           ; 

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

UseJPEG2000ImageDecoder()                                                                            ; PureBasic native image decoder
UseJPEGImageDecoder()                                                                                ; PureBasic native image decoder
UsePNGImageDecoder()                                                                                 ; PureBasic native image decoder
UseTGAImageDecoder()                                                                                 ; PureBasic native image decoder
UseTIFFImageDecoder()                                                                                ; PureBasic native image decoder

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

UseODBCDatabase()                                                                                    ; 
UseSQLiteDatabase()                                                                                  ; 

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

UseZipPacker()                                                                                        ; 

;==============================================================================================================================================================================
; Program constants that don't need to change. Wordier to allow easier error tracking
;==============================================================================================================================================================================

#ListIconHeadingArea            = -1                                                                  ; 

#AtTheEndOfTheList              = -1                                                                  ; 

#NoItems                        = 0                                                                   ; 
#FirstItem                      = 0                                                                   ; 

#NothingFound                   = 0                                                                   ; 
#NothingSelected                = -1                                                                  ; 

#NoDataFound                    = 0                                                                   ; 
#NoBlobFound                    = 0                                                                   ; 
#NoPictureHandle                = 0                                                                   ; 
#NoPictureFound                 = -1                                                                  ; 
#NoPictureLoaded                = 0                                                                   ; 
#NoPictureResized               = 0                                                                   ; 

#NoColumnIcon                   = 0                                                                   ; 
#NoData                         = 0                                                                   ; 
#NoCurrentLine                  = -1                                                                  ; Make sure no line can be selected accidentally
#NoRecordNumber                 = ""                                                                  ; 
#EmptyString                    = ""                                                                  ; 

#RecipeDeleted                  = 1                                                                   ; 
#RecipeLocked                   = 1                                                                   ; 
#RecipeFavourite                = 1                                                                   ; 

#DatabaseOpenFail               = 0                                                                   ; 
#DatabaseQueryFail              = 0                                                                   ; 
#DatabaseUpdateFail             = 0                                                                   ; 

#NoFileHandle                   = 0                                                                   ; 
#NotEndOfFile                   = 0                                                                   ; 
#FileIsEmpty                    = 0                                                                   ; 
#FileNotDecompressed            = -1                                                                  ; 
#FileIsDirectory                = -2                                                                  ; 

#DirectoryNotCreated            = 0                                                                   ; 

#NoPrintFileHandle              = 0                                                                   ; 
#NoImportFileHandle             = 0                                                                   ; 
#NoExportFileHandle             = 0                                                                   ; 

#NoMenuCreated                  = 0                                                                   ; 

#TitleBarClockTimerEvent        = 624                                                                 ; Title bar clock timer event

#Fish                           = "<°)))o><²³  "                                                      ; Beware the fish!!

#PictureBufferSize              = 10000000                                                            ; 

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

#ODBC_ADD_DSN                       =   1 ; Add Data source
#ODBC_ADD_SYS_DSN                   =   4 ; Add SYSTEM Data source
#ODBC_CONFIG_DSN                    =   2 ; Configure (edit) Data source
#ODBC_REMOVE_DSN                    =   3 ; Remove Data source
#ODBC_REMOVE_SYS_DSN                =   6 ; Remove SYSTEM Data source

#SQL_SUCCESS                        =   0
#SQL_SUCCESS_WITH_INFO              =   1
#SQL_ERROR                          =  -1
#SQL_INVALID_HANDLE                 =  -2
#SQL_NO_DATA                        = 100
#SQL_MAX_MESSAGE_LENGTH             = 512
#SQL_NTS                            =  -3
#SQL_HANDLE_ENV                     =   1;?
#SQL_HANDLE_DBC                     =   2;?
#SQL_HANDLE_STMT                    =   3
#SQL_HANDLE_DESC                    =   4;?
#SQL_C_CHAR                         =   1

#ODBC_ERROR_GENERAL_ERR             =   1
#ODBC_ERROR_INVALID_BUFF_LEN        =   2
#ODBC_ERROR_INVALID_HWND            =   3
#ODBC_ERROR_INVALID_STR             =   4
#ODBC_ERROR_INVALID_REQUEST_TYPE    =   5
#ODBC_ERROR_COMPONENT_NOT_FOUND     =   6
#ODBC_ERROR_INVALID_NAME            =   7
#ODBC_ERROR_INVALID_KEYWORD_VALUE   =   8
#ODBC_ERROR_INVALID_DSN             =   9
#ODBC_ERROR_INVALID_INF             =  10
#ODBC_ERROR_REQUEST_FAILED          =  11
#ODBC_ERROR_INVALID_PATH            =  12
#ODBC_ERROR_LOAD_LIB_FAILED         =  13
#ODBC_ERROR_INVALID_PARAM_SEQUENCE  =  14
#ODBC_ERROR_INVALID_LOG_FILE        =  15
#ODBC_ERROR_USER_CANCELED           =  16
#ODBC_ERROR_USAGE_UPDATE_FAILED     =  17
#ODBC_ERROR_CREATE_DSN_FAILED       =  18
#ODBC_ERROR_WRITING_SYSINFO_FAILED  =  19
#ODBC_ERROR_REMOVE_DSN_FAILED       =  20
#ODBC_ERROR_OUT_OF_MEM              =  21
#ODBC_ERROR_OUTPUT_STRING_TRUNCATED =  22

;==============================================================================================================================================================================
; My personal constants - Program details etc
;==============================================================================================================================================================================

#Author                         = "Miklos G Bolvary, Bernd Kruger Knauber"                          ; Author's name
#CopyRight                      = "Both of us! "                                                    ; Copyright holder
#Basename                       = "MasterImport "                                                   ; Base name for ini and dataabse
#Version                        = "v0.00 "                                                          ; Program version
#Program                        = #Basename + #Version                                              ; Copyright string
#Fish                           = "<°)))o><²³  "                                                    ; My favourite fish!!

;========================================================================================================================================================== 
; Program data variables
;==========================================================================================================================================================

Structure ProgramData
  CurrentDirectory.s
  TemporaryDirectory.s
  DatabaseHandle.i
  Databasename.s
  CrbPassword.s 
EndStructure

;========================================================================================================================================================== 
; Picture data structure
;==========================================================================================================================================================

Structure PictureData
  FileType.s
  FileName.s
  OriginalFileName.s
  Description.s
  *PictureBuffer
  PictureBufferPtr.i
EndStructure

; ;========================================================================================================================================================== 
; ; Temporary Ingredient list data structure
; ;==========================================================================================================================================================
; 
; Structure IngredientListStructure
;   Column.i
;   Measure.s
;   Unit.s
;   Ingredient.s
; EndStructure

;========================================================================================================================================================== 
; Ingredient table data structure
;==========================================================================================================================================================

Structure IngredientData
; Ingredientid.s  Auto increment field during recipe save
  Unit.s
  Measure.s
  Ingredient.s
  Preparation.s
  LineOrder.s
  RecipeId.s
EndStructure

;========================================================================================================================================================== 
; Recipe table data structure
;==========================================================================================================================================================

Structure RecipeData
  Recipetitle.s
  Numberofservings.s
  Recipeauthor.s
  Categories.s
  Subcategories.s
  Preparationtime.s
  Cookingtime.s
  Difficulty.s
  Recipeversion.s
  Recipesource.s
  Copyright.s
  Cuisine.s
  Reciperating.s
  Importedfrom.s
  Authorcomments.s
  Instructions.s
  Nutritionaldata.s
  Othercomments.s
  Deleted.s
  Updated.s
  Favourite.s
  Locked.s
  RecordId.s
  List IngredientList.IngredientData()
  List PictureList.PictureData()
EndStructure

;========================================================================================================================================================== 
; Global declarations
;==========================================================================================================================================================

Global Program.ProgramData
Global Recipe.RecipeData

Global NewList FoundDirs.s()                                                                      ; List of recursed import directories

;========================================================================================================================================================== 
; Current dirrectory reference for file use
;==========================================================================================================================================================

Program\CurrentDirectory    = GetCurrentDirectory()
Program\TemporaryDirectory  = GetTemporaryDirectory()

;========================================================================================================================================================== 
; Create the database name that I am going to use
;==========================================================================================================================================================

Program\DatabaseName        = Program\CurrentDirectory + "Master Importer test.sqlite"

;========================================================================================================================================================== 
; Create the database name that I am going to use
;==========================================================================================================================================================

Program\CrbPassword         = "mealpoint123"                                                        ; 

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 252
; FirstLine = 207
; EnableAsm
; EnableUnicode
; EnableXP
; CompileSourceDirectory