﻿;==============================================================================================================================================================================
; Import the Food Data Exchange recipe
;==============================================================================================================================================================================

Procedure ImportFoodDataExchangeFile(ImportFileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected.i XML, RecipeDataExchangeFile
  
  Protected   RecipeDataExchangeFileSize.q
  
  Protected   *Buffer, *Node
  
  ;------------------------------------------------------------------------------------------------
  ; Count the old number of items in the display
  ;------------------------------------------------------------------------------------------------
  
  RecipeDataExchangeFile.i = ReadFile(#PB_Any, ImportFilename.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If RecipeDataExchangeFile.i
    
    ; Show the currently processed file on the import window title bar
    
    RecipeDataExchangeFileSize.q = Lof(RecipeDataExchangeFile.i)
    
    If RecipeDataExchangeFileSize.q
      
      *Buffer = AllocateMemory(RecipeDataExchangeFileSize.q)
      
      If *Buffer
        
        If ReadData(RecipeDataExchangeFile, *Buffer, RecipeDataExchangeFileSize.q) = RecipeDataExchangeFileSize.q
          
          XML = CatchXML(#PB_Any, *Buffer, RecipeDataExchangeFileSize.q)
          
          If XML
            
            If XMLStatus(XML) = #PB_XML_Success
              
              *Node = MainXMLNode(XML)
              
              If *Node
                
                ImportFoodDataExchangeFile_XML(ImportFileName.s, *Node, 0)
                
              Else
                
                Debug ImportFileName.s  +  " main node could not be allocated."
                
              EndIf
              
            Else
              
              Debug "The XML data inside " + ImportFileName.s  + " is faulty."
              
            EndIf
            
            FreeXML(XML)
            
          Else
            
            Debug ImportFileName.s  +  " could not be loaded as XML data."
            
          EndIf
          
        Else
          
          Debug ImportFileName.s  +  " could not be read into the memory buffer."
          
        EndIf
        
        FreeMemory(*Buffer)
        
      Else
        
        Debug ImportFileName.s  +  " could not be allocated a memory buffer."
        
      EndIf
      
    Else
      
      Debug ImportFileName.s  +  " is empty, cannot get the length of the file."
      
    EndIf
    
    CloseFile(RecipeDataExchangeFile.i)
    
  Else
    
    Debug ImportFileName.s  +  " could not be opened, there is no file handle."
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 4
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP
; CompileSourceDirectory