﻿;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

Procedure.i ImportMasterCookIIFile(ImportFilename.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected.i XML, MasterCookIIFile.i
  
  Protected.q MasterCookSize.q
  
  Protected *Buffer, *Node
  
  Protected Bug.s
  
  ;------------------------------------------------------------------------------------------------
  ; Count the old number of items in the display
  ;------------------------------------------------------------------------------------------------
  
  MasterCookIIFile.i = ReadFile(#PB_Any, ImportFilename.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If MasterCookIIFile.i
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    MasterCookSize.q = Lof(MasterCookIIFile.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    *Buffer = AllocateMemory(MasterCookSize.q)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If *Buffer
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If ReadData(MasterCookIIFile.i, *Buffer, MasterCookSize.q) = MasterCookSize.q
        
        ;------------------------------------------------------------------------------------------
        ; bugfix for standalone at wrong place
        ;------------------------------------------------------------------------------------------
        
        Bug.s = PeekS(*Buffer, 100, #PB_Ascii)
        
        Bug.s = ReplaceString(Bug.s, "standalone=" + #DQUOTE$ + "yes" + #DQUOTE$, "                ")
        
        Bug.s = ReplaceString(Bug.s, "standalone=" + #DQUOTE$ + "no"  + #DQUOTE$, "               ")
        
        ;------------------------------------------------------------------------------------------
        ; Debug Bug$
        ;------------------------------------------------------------------------------------------
        
        ; CopyMemory(@Bug.s, *Buffer, 100)
        
        PokeS(*Buffer, Bug.s, -1, #PB_Ascii|#PB_String_NoZero)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        XML = CatchXML(#PB_Any, *Buffer, MasterCookSize.q)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If XML
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          *Node = MainXMLNode(XML)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If *Node
            
            ImportMasterCookIIFile_XML(ImportFilename.s, *Node, 0)
            
          Else
            
            Debug "No main xml node in:  " + ImportFilename.s
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          FreeXML(XML)          
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          Debug "XML data loaded was not valid: " + ImportFilename.s
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        Debug "Could not read the data from the file"
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      FreeMemory(*Buffer)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CloseFile(MasterCookIIFile.i)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    Debug "File wasn't opened, no there is file handle."
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure 
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 116
; FirstLine = 69
; Folding = -
; EnableXP