﻿;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

Procedure ImportMasterCookIIFile_XML(ImportFileName.s, *CurrentNode, CurrentSublevel.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  Protected NodeName.s, *ChildNode, AttributeName.s, qty.s, unit.s, name.s, AttributeValue.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If XMLNodeType(*CurrentNode) = #PB_XML_Normal
    
    NodeName.s = GetXMLNodeName(*CurrentNode)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If NodeName.s                   = "RcpE"
      
      If Recipe\Recipetitle <> ""
        
        Recipe\Categories           = Trim(Recipe\Categories, ",")
        
        SaveImportRecipe(ImportFileName.s)
        
        ClearRecipeStructure()
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If ExamineXMLAttributes(*CurrentNode)
        
        While NextXMLAttribute(*CurrentNode)
          
          AttributeName.s = XMLAttributeName(*CurrentNode)
          
          If AttributeName.s        = "name"
            
            Recipe\Recipetitle      = RecipeCRLFSpaceTrim(XmlToText(XMLAttributeValue(*CurrentNode)))
            
            Recipe\Recipetitle      = ReplaceString(Recipe\Recipetitle.s, "'", "''")
            
            Recipe\Recipetitle.s    = ProperCaseString(Recipe\Recipetitle.s)
            
          ElseIf AttributeName.s   = "author"
            
            Recipe\Copyright.s      = XMLAttributeValue(*CurrentNode)
            
            Recipe\Copyright.s      = ReplaceString(Recipe\Copyright.s, "'", "''")
            
          EndIf
          
        Wend
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    ElseIf NodeName.s              = "Serv"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If ExamineXMLAttributes(*CurrentNode)
        
        While NextXMLAttribute(*CurrentNode)
          
          AttributeName.s = XMLAttributeName(*CurrentNode)
          
          If AttributeName.s        = "qty"
            
            Recipe\Numberofservings = XMLAttributeValue(*CurrentNode)
            
            Recipe\Numberofservings = ReplaceString(Recipe\Numberofservings.s, "'", "''")
            
          EndIf
          
        Wend
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    ElseIf NodeName.s              = "CatT"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Recipe\Subcategories             + RecipeCRLFSpaceTrim(XmlToText(GetXMLNodeText(*CurrentNode))) + ","
      
      Recipe\Subcategories             = ReplaceString(Recipe\Subcategories.s, "'", "''")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    ElseIf NodeName.s              = "IngR"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      AddElement(Recipe\IngredientList())
      
      If ExamineXMLAttributes(*CurrentNode)
        
        While NextXMLAttribute(*CurrentNode)
          
          AttributeName.s           = XMLAttributeName(*CurrentNode)
          
          AttributeValue.s          = ReplaceString(XMLAttributeValue(*CurrentNode), "'", "''")
          
          Select AttributeName.s
              
            Case "qty"
              
              Recipe\IngredientList()\Unit        = AttributeValue.s
              
            Case "unit"
              
              Recipe\IngredientList()\Measure     = CorrectIngredientMeasure(AttributeValue.s)  ; Correct single letter ingredient measure strings
              
            Case "name"
              
              Recipe\IngredientList()\Ingredient  = AttributeValue.s
              
          EndSelect
          
        Wend
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    ElseIf NodeName.s = "DirT"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Recipe\Instructions           + ReplaceString(RecipeCRLFSpaceTrim(XmlToText(GetXMLNodeText(*CurrentNode))), "'", "''") + #LF$
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    ElseIf NodeName.s              = "Srce"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Recipe\Recipesource           + RecipeCRLFSpaceTrim(XmlToText(GetXMLNodeText(*CurrentNode))) + ","
      
      Recipe\Recipesource           = ReplaceString(Recipe\Recipesource.s, "'", "''")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    ElseIf NodeName.s              = "Nutr"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Recipe\Nutritionaldata.s      + RecipeCRLFSpaceTrim(XmlToText(GetXMLNodeText(*CurrentNode))) + #LF$
      
      Recipe\Nutritionaldata.s      = ReplaceString(Recipe\Nutritionaldata.s, "'", "''")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    *ChildNode = ChildXMLNode(*CurrentNode)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    While *ChildNode <> 0
      
      ImportMasterCookIIFile_XML(ImportFileName.s, *ChildNode, CurrentSublevel + 1)
      
      *ChildNode = NextXMLNode(*ChildNode)
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; To make sure to save the last record and free the picture memory if any
    ;----------------------------------------------------------------------------------------------
    
    If *ChildNode = 0 And CurrentSublevel = 0
      
      If Len(Recipe\Recipetitle.s)  <> 0
        
        SaveImportRecipe(ImportFileName.s)  ; Save the filled fields of the recipe structure
        
        ClearRecipeStructure()
        
      EndIf
      
    EndIf    
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 160
; FirstLine = 146
; Folding = -
; EnableXP