﻿;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

Procedure.i ImportRecipeMLFile_XML(ImportFileName.s, *CurrentNode, CurrentSublevel.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected NodeName.s, *ChildNode, AttributeName.s, AttributeValue.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If XMLNodeType(*CurrentNode) = #PB_XML_Normal
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    NodeName.s = GetXMLNodeName(*CurrentNode)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ; Debug NodeName.s
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If NodeName.s               = "title"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Recipe\Recipetitle.s      = RecipeCRLFSpaceTrim(XmlToText(GetXMLNodeText(*CurrentNode)))
      
      Recipe\Recipetitle.s      = ReplaceString(Recipe\Recipetitle.s, "'", "''")                            ;: Debug "Title seems okay: "  + Recipe\Recipetitle
      
      Recipe\Recipetitle.s      = ProperCaseString(Recipe\Recipetitle.s)   
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    ElseIf NodeName.s           = "cat"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Recipe\Categories.s       + RecipeCRLFSpaceTrim(XmlToText(GetXMLNodeText(*CurrentNode))) + ","        ;: Debug Recipe\Categories
      
      Recipe\Categories.s       = ReplaceString(Recipe\Categories.s, "'", "''")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    ElseIf NodeName.s           = "yield"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Recipe\Numberofservings.s + RecipeCRLFSpaceTrim(XmlToText(GetXMLNodeText(*CurrentNode)))              ;: Debug Recipe\Numberofservings
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ElseIf NodeName.s         = "qty"
        
        AddElement(Recipe\IngredientList())
        
        Recipe\IngredientList()\Unit        = RecipeCRLFSpaceTrim(XmlToText(GetXMLNodeText(*CurrentNode)))  ;: Debug  Recipe\IngredientList()\Unit
        
      ElseIf NodeName.s         = "unit"
        
        Recipe\IngredientList()\Measure     = RecipeCRLFSpaceTrim(XmlToText(GetXMLNodeText(*CurrentNode)))  ;: Debug  Recipe\IngredientList()\Measure
        
        Recipe\IngredientList()\Measure     = CorrectIngredientMeasure(Recipe\IngredientList()\Measure)     ; Correct single letter ingredient measure strings
        
      ElseIf NodeName.s         = "item"
        
        Recipe\IngredientList()\Ingredient  = RecipeCRLFSpaceTrim(XmlToText(GetXMLNodeText(*CurrentNode)))  ;: Debug  Recipe\IngredientList()\Ingredient
        
        Recipe\IngredientList()\Ingredient  = ReplaceString(Recipe\IngredientList()\Ingredient, "'", "''")
        
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    ElseIf NodeName.s           = "step"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Recipe\Instructions.s     + RecipeCRLFSpaceTrim(XmlToText(GetXMLNodeText(*CurrentNode))) + #LF$         ;: Debug Recipe\Instructions
      
      Recipe\Instructions.s     = ReplaceString(Recipe\Instructions.s, "'", "''")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    *ChildNode                  = ChildXMLNode(*CurrentNode)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    While *ChildNode <> 0
      
      ImportRecipeMLFile_XML(ImportFileName.s, *ChildNode, CurrentSublevel + 1)
      
      *ChildNode = NextXMLNode(*ChildNode)
      
    Wend   
    
    ;----------------------------------------------------------------------------------------------
    ; To make sure to save the last record and free the picture memory if any
    ;----------------------------------------------------------------------------------------------
    
    If *ChildNode = 0 And CurrentSublevel = 0
      
      If Len(Recipe\Recipetitle)  <> 0
        
        SaveImportRecipe(ImportFileName.s)  ; Save the filled fields of the recipe structure
        
        ClearRecipeStructure()
        
      EndIf
      
    EndIf    
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 86
; FirstLine = 82
; Folding = -
; EnableXP