﻿;==============================================================================================================================================================================
; Multiple file import
;==============================================================================================================================================================================

Procedure.i RequestMealMasterFile()
  
  Protected ResultFlag.i, RecipeName.s, PackHandle.i
  
  ; Ask the user for a standard MealMaster MMF text recipe file
  
  RecipeName.s = OpenFileRequester("Select recipe file", GetCurrentDirectory(), "MMF (*.MMF)|*.MMF", 0, #PB_Requester_MultiSelection)
  
  ; If the user didn't cancel, do the code below
  
  If RecipeName.s <> #EmptyString
    
    DatabaseUpdate(Program\DatabaseHandle, "BEGIN TRANSACTION")
    
    While RecipeName.s 
      
      ; Check to see if the recipe is valid and undamaged
      
      If FileSize(RecipeName.s) <> #FileIsEmpty
        
        ImportMealMasterFile(RecipeName.s)
        
      Else
        
        Debug "The selected file was not found"
        
      EndIf
      
      RecipeName.s = NextSelectedFileName() 
      
    Wend
    
    DatabaseUpdate(Program\DatabaseHandle, "COMMIT")
    
  Else
    
    Debug "Nothing to do as user cancelled the operation"
    
  EndIf
  
  ProcedureReturn ResultFlag
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 8
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP
; HideErrorLog
; CompileSourceDirectory