﻿;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

Procedure SaveImportRecipe(ImportFileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected DatabaseUpdate.s, FileIn.i, FileInSize.i, DatabaseErrorString.s, FileSize.i
  
  Protected FileNameOnly.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  FileNameOnly.s  = GetFilePart(ImportFileName.s)

  ;------------------------------------------------------------------------------------------------
  ; Only proceed if the title field at least has something in it
  ;------------------------------------------------------------------------------------------------
  
  If Len(Recipe\Recipetitle) <> 0
    
    Recipe\Deleted  = "0"
    
    Recipe\Locked   = "0"
    
    DatabaseUpdate.s = "INSERT INTO Recipes("
    
    DatabaseUpdate.s + "Recipetitle, "
    
    DatabaseUpdate.s + "Numberofservings, "
    
    DatabaseUpdate.s + "Recipeauthor, "
    
    DatabaseUpdate.s + "Categories, "
    
    DatabaseUpdate.s + "Subcategories, "
    
    DatabaseUpdate.s + "Preparationtime, "
    
    DatabaseUpdate.s + "Cookingtime, "
    
    DatabaseUpdate.s + "Difficulty, "
    
    DatabaseUpdate.s + "Recipeversion, "
    
    DatabaseUpdate.s + "Recipesource, "
    
    DatabaseUpdate.s + "Copyright, "
    
    DatabaseUpdate.s + "Reciperating, "
    
    DatabaseUpdate.s + "Importedfrom, "
    
    DatabaseUpdate.s + "Authorcomments, "
    
    DatabaseUpdate.s + "Instructions, "
    
    DatabaseUpdate.s + "Nutritionaldata, "
    
    DatabaseUpdate.s + "Othercomments, "
    
    DatabaseUpdate.s + "Deleted, "
    
    DatabaseUpdate.s + "Updated, "
    
    DatabaseUpdate.s + "Favourite, "
    
    DatabaseUpdate.s + "Locked) "
    
    DatabaseUpdate.s + "VALUES("
    
    DatabaseUpdate.s + "'" + Recipe\Recipetitle      + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Numberofservings + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Recipeauthor     + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Categories       + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Subcategories    + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Preparationtime  + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Cookingtime      + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Difficulty       + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Recipeversion    + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Recipesource     + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Copyright        + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Reciperating     + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Importedfrom     + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Authorcomments   + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Instructions     + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Nutritionaldata  + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Othercomments    + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Deleted          + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Updated          + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Favourite        + "', "
    
    DatabaseUpdate.s + "'" + Recipe\Locked           + "')"
    
    ;----------------------------------------------------------------------------------------------
    ; Now update the database with the new record
    ;----------------------------------------------------------------------------------------------
    
    If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
      
      ;--------------------------------------------------------------------------------------------
      ; Get the new record number if any
      ;--------------------------------------------------------------------------------------------

      Recipe\Recordid = DatabaseLastInsertRowId()

      ;--------------------------------------------------------------------------------------------
      ; Proceed if we got a new record number
      ;--------------------------------------------------------------------------------------------

      If Len(Recipe\Recordid)
        
        ForEach Recipe\IngredientList()
          
          DatabaseUpdate.s  = "INSERT INTO Ingredients("
          
          DatabaseUpdate.s  + "Unit, "
          
          DatabaseUpdate.s  + "Measure, "
          
          DatabaseUpdate.s  + "Ingredient, "
          
          DatabaseUpdate.s  + "Preparation, "
          
          DatabaseUpdate.s  + "Lineorder, "
          
          DatabaseUpdate.s  + "Recordid) "
          
          DatabaseUpdate.s  + "VALUES("
          
          DatabaseUpdate.s  + "'" + Recipe\IngredientList()\Unit            + "', "
          
          DatabaseUpdate.s  + "'" + Recipe\IngredientList()\Measure         + "', "
          
          DatabaseUpdate.s  + "'" + Recipe\IngredientList()\Ingredient      + "', "
          
          DatabaseUpdate.s  + "'" + Recipe\IngredientList()\Preparation     + "', "
          
          DatabaseUpdate.s  + "'" + Recipe\IngredientList()\Lineorder       + "', "
          
          DatabaseUpdate.s  + "'" + Recipe\Recordid                         + "')"
          
          If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <>  #DatabaseUpdateFail
            
            ; Debug "New ingredient saved for recipe"
            
          Else
            
            ; Debug "New igredient not saved for recipe" + DatabaseError()
            
          EndIf
          
        Next 
        
        ;------------------------------------------------------------------------------------------
        ; ClearList(Ingredients())
        ;------------------------------------------------------------------------------------------
        
        ForEach Recipe\PictureList()
          
          If FileSize.i <> Recipe\PictureList()\PictureBufferPtr
            
            FileSize.i = Recipe\PictureList()\PictureBufferPtr
            
            ; SetDatabaseBlob(Program\DatabaseHandle, 0, Recipe\PictureList()\PictureBuffer, Recipe\PictureList()\PictureBufferPtr)
            
            SetDatabaseBlob(Program\DatabaseHandle, 0, Recipe\PictureList()\PictureBuffer, FileSize.i)
            
            DatabaseUpdate.s = "INSERT INTO Pictures("
            
            DatabaseUpdate.s + "Picture, "
            
            DatabaseUpdate.s + "FileName, "
            
            DatabaseUpdate.s + "Description, "
            
            DatabaseUpdate.s + "Recordid) "
            
            DatabaseUpdate.s + "VALUES("
            
            DatabaseUpdate.s + "?, "
            
            DatabaseUpdate.s + "'"  + Recipe\PictureList()\OriginalFileName + "', "
            
            DatabaseUpdate.s + "'"  + Recipe\PictureList()\Description      + "', "
            
            DatabaseUpdate.s + "'"  + Recipe\Recordid                       + "')"
            
            If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s)  <> #DatabaseUpdateFail
              
              ; Debug "Picture saved for this recipe"
              
            Else
              
              ; Debug "Could not save picture from list" +  DatabaseError()
              
            EndIf
            
          Else
            
            ; This picture may be a duplicate of the previous
            
          EndIf
          
        Next
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        Debug "Saved: " + KillQuote(Recipe\Recipetitle.s) + " program: "  + Recipe\Importedfrom.s + " File: "  + FileNameOnly.s
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        Debug "Database failed to be updated so we didn't get a new record number."
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      DatabaseErrorString.s = DatabaseError()
      
      If FindString(DatabaseErrorString.s, "are not unique", 1, #PB_String_NoCase) = 0
        
        Debug "Recipe:  " + KillQuote(Recipe\Recipetitle)  + " from: "  + FileNameOnly.s + " could not be saved: " + DatabaseErrorString.s
        Debug DatabaseUpdate.s
      EndIf
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; Saving an edited record
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ;Debug "You are not allowed to save a recipe without a title!!"
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 268
; FirstLine = 232
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP
; CompileSourceDirectory